// Calc.cpp : Implementation of CCalc
#include "stdafx.h"
#include "Calculator.h"
#include "Calc.h"

#include "StackComponent2002_i.c"
/////////////////////////////////////////////////////////////////////////////
// CCalc

CCalc::CCalc() {
		HRESULT hr;
		int val;

		IUnknown * pUnknown;

		CoInitialize(NULL);

		hr = CoCreateInstance( CLSID_IStack2002, NULL, CLSCTX_SERVER, IID_IUnknown,
						  (void **) &pUnknown);
		if (FAILED(hr)) {
			stack_initialized = 0;
			return;
		}
		hr = pUnknown->QueryInterface( IID_IIStack2002, (void**) &pStack);
		if (FAILED(hr)) {
			stack_initialized = 0;
			return;
		}	
		pUnknown->Release();
		stack_initialized = 1;
}

CCalc::~CCalc() {
	if (stack_initialized)
		pStack->Release();
}

STDMETHODIMP CCalc::Add(int x, int y, int *z)
{
	// TODO: Add your implementation code here

	*z = x + y;
	memory = *z;
	return S_OK;
}

STDMETHODIMP CCalc::Sub(int x, int y, int *z)
{
	// TODO: Add your implementation code here

	*z = x - y;
	memory = *z;
	return S_OK;
}

STDMETHODIMP CCalc::Mult(int x, int y, int *z)
{
	// TODO: Add your implementation code here

	*z = x * y;
	memory = *z;
	return S_OK;
}

STDMETHODIMP CCalc::getMem(int *z)
{
	// TODO: Add your implementation code here

	if (!stack_initialized)
		*z = memory;
	else
		pStack->pop( z );	
	return S_OK;
}

STDMETHODIMP CCalc::putMem(int x)
{
	// ZU ERLEDIGEN: Implementierungscode hier hinzufgen

	if (!stack_initialized)
		memory = x;
	else
		pStack->push( x );
	return S_OK;
}
